// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from foxglove_msgs:msg/LocationFix.idl
// generated code does not contain a copyright notice

#include "foxglove_msgs/msg/detail/location_fix__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_foxglove_msgs
const rosidl_type_hash_t *
foxglove_msgs__msg__LocationFix__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xa0, 0x6f, 0xa6, 0x2b, 0x1f, 0xf0, 0x54, 0x7b,
      0xb3, 0x10, 0x79, 0xb7, 0x6f, 0xec, 0x5f, 0x96,
      0xef, 0xbc, 0xca, 0xad, 0x1c, 0x3c, 0xa8, 0xcd,
      0x40, 0xda, 0xc6, 0x41, 0xdb, 0x3f, 0xc5, 0x97,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char foxglove_msgs__msg__LocationFix__TYPE_NAME[] = "foxglove_msgs/msg/LocationFix";

// Define type names, field names, and default values
static char foxglove_msgs__msg__LocationFix__FIELD_NAME__latitude[] = "latitude";
static char foxglove_msgs__msg__LocationFix__FIELD_NAME__longitude[] = "longitude";
static char foxglove_msgs__msg__LocationFix__FIELD_NAME__altitude[] = "altitude";
static char foxglove_msgs__msg__LocationFix__FIELD_NAME__position_covariance[] = "position_covariance";
static char foxglove_msgs__msg__LocationFix__FIELD_NAME__position_covariance_type[] = "position_covariance_type";

static rosidl_runtime_c__type_description__Field foxglove_msgs__msg__LocationFix__FIELDS[] = {
  {
    {foxglove_msgs__msg__LocationFix__FIELD_NAME__latitude, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {foxglove_msgs__msg__LocationFix__FIELD_NAME__longitude, 9, 9},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {foxglove_msgs__msg__LocationFix__FIELD_NAME__altitude, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {foxglove_msgs__msg__LocationFix__FIELD_NAME__position_covariance, 19, 19},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE_ARRAY,
      9,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {foxglove_msgs__msg__LocationFix__FIELD_NAME__position_covariance_type, 24, 24},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
foxglove_msgs__msg__LocationFix__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {foxglove_msgs__msg__LocationFix__TYPE_NAME, 29, 29},
      {foxglove_msgs__msg__LocationFix__FIELDS, 5, 5},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# foxglove_msgs/msg/LocationFix\n"
  "# A navigation satellite fix for any Global Navigation Satellite System\n"
  "\n"
  "# Generated by https://github.com/foxglove/schemas\n"
  "\n"
  "# Latitude in degrees\n"
  "float64 latitude\n"
  "\n"
  "# Longitude in degrees\n"
  "float64 longitude\n"
  "\n"
  "# Altitude in meters\n"
  "float64 altitude\n"
  "\n"
  "# Position covariance (m^2) defined relative to a tangential plane through the reported position. The components are East, North, and Up (ENU), in row-major order.\n"
  "float64[9] position_covariance\n"
  "\n"
  "uint8 UNKNOWN=0\n"
  "uint8 APPROXIMATED=1\n"
  "uint8 DIAGONAL_KNOWN=2\n"
  "uint8 KNOWN=3\n"
  "\n"
  "# If `position_covariance` is available, `position_covariance_type` must be set to indicate the type of covariance.\n"
  "uint8 position_covariance_type";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
foxglove_msgs__msg__LocationFix__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {foxglove_msgs__msg__LocationFix__TYPE_NAME, 29, 29},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 696, 696},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
foxglove_msgs__msg__LocationFix__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *foxglove_msgs__msg__LocationFix__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
